#!/usr/bin/python
########################################
#
#      Copyright 2014, 2015 Timothy Evans
#
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 3 of the License, or
#      (at your option) any later version.
#      
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
########################################
#
# Script to  create random files and call tester.sh
#
########################################
#
# Notes
#
# on i7 can take 26 hours, 13 min, 49.46s
#
########################################
import sys
import os
import random
import time
starttime = time.time()
if not os.path.isfile("tester.sh"):
	print ('tester.sh missing')
	exit()
temptestdir = "gsecraiftesting"
testfilename = "testfile"
testfilename2 = "testfile2"
path2testfile = sys.path[0]
path2testfile = path2testfile+"/"
mkdircmd = "mkdir "+temptestdir
if not os.path.isdir(temptestdir):
	os.system(mkdircmd)

# Test null file:
touchcmd = "touch "+testfilename
exitstatus = os.system(touchcmd)
if (exitstatus != 0):
	print ('can not create file')
	exit()
print ('testing with null file')
testcmd = "./tester.sh -d "+temptestdir+" "+path2testfile+testfilename
#testcmd = "./tester.sh -d "+temptestdir+" "+path2testfile+testfilename+" 2> errors.txt"
exitstatus = os.system(testcmd)
if (exitstatus != 0):
	print ('failed testing null file')
	exit()

# Test small files 1 to 10 bytes:
bytecount = 1
maxbytes = 10
while bytecount <= maxbytes:
	byte = chr(random.randrange(255))
	#byte=chr(random.randrange(64, 128))
	print ('%s %s %s' % ('testing ', bytecount, ' byte file'))
	# append binary
	testfile = open(testfilename, 'ab')
	testfile.write(byte)
	testfile.close()
	exitstatus = os.system(testcmd)
	if (exitstatus != 0):
        	print ('failed testing file')
        	exit()
 	bytecount += 1

# Create 1K file:

testfile = open(testfilename, 'ab')
while bytecount <= 1024:
	byte = chr(random.randrange(255))
	testfile.write(byte)
	bytecount += 1
testfile.close()
print ('testing 1K file')
exitstatus = os.system(testcmd)
if (exitstatus != 0):
	print ('failed testing file')
	exit()
cpcmd = "cp "+testfilename+" "+testfilename2 
#cpcmd2 = "cp "+testfilename+" "+testfilename3 
os.system(cpcmd)
catcmd = "cat "+testfilename2+" >> "+testfilename

# Test files 2 to 8K:
kcount = 2
maxk = 8
while kcount <= maxk:
	os.system(catcmd)
	print ('%s %s %s' % ('testing ', kcount, 'K file'))
	exitstatus = os.system(testcmd)
	if (exitstatus != 0):
        	print ('failed testing file')
        	exit()
	kcount += 1

kcount = 8
dblcount = 1
maxdbl = 7
#maxdbl = 2

# Test nK to 1M: 

while dblcount <= maxdbl:
	os.system(cpcmd)
	os.system(catcmd)
	kcount = kcount * 2
	print ('%s %s %s' % ('testing ', kcount, 'K file'))
	exitstatus = os.system(testcmd)
	if (exitstatus != 0):
        	print ('failed testing file')
        	exit()	
	dblcount += 1

mcount = 1
dblcount = 1
maxdbl = 7
#maxdbl = 0
#maxdbl = 2
#maxdbl = 4
testcmd = "./tester.sh -v 3 -d "+temptestdir+" "+path2testfile+testfilename
 
# Test 1M to 128M:

while dblcount <= maxdbl:
	os.system(cpcmd)
	os.system(catcmd)
	mcount = mcount * 2
	print ('%s %s %s' % ('testing ', mcount, 'M file'))
	exitstatus = os.system(testcmd)
	if (exitstatus != 0):
        	print ('failed testing file')
        	exit()	
	dblcount += 1

elapsedtime = time.time() - starttime
elapsedminutes = int(elapsedtime / 60)
elapsedseconds = elapsedtime - (60 * elapsedminutes)
print ('testing complete')
print ('%s %s %s %s' % ('Elapsed time: ', elapsedminutes, ':', elapsedseconds))

# Clean up:

rmfilecmd = "rm "+testfilename
os.system(rmfilecmd)
rmfilecmd = "rm "+testfilename2
os.system(rmfilecmd)
rmdircmd = "rmdir "+temptestdir
os.system(rmdircmd)

##########

