//
//      Copyright 2014, 2015 Timothy Evans
//
//      This file is part of gsecraif.
//
//      gsecraif is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 3 of the License, or
//      (at your option) any later version.
//
// split_functions
//

#ifndef SPLIT_FUNCTIONS_H
#define SPLIT_FUNCTIONS_H

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <cstdlib>
#include <sstream>
#include <algorithm>
#include <string>
#include <vector>

#include "int2asciistr.h"
#include "parity.h"
#include "bit_rotate.h"
#include "bit_transpose.h"
#include "parse_args.h"
#include "print_help.h"
#include "stripe.h"
#include "errors_text.h"

void read_orig_bytes(int bytestoread, vector<unsigned char> &bytes,
                     bool &eofile, bool &finished, unsigned int &bytescount, 
                     unsigned short int &padbytes, bool &nullstripe,
                     ifstream &in);

void split_input(int numoffiles, unsigned short int rrotate, bool transpose,   
                 vector<string> &compfilenames); 

#endif
